// @ts-nocheck

import CPDFAnnotation from "./CPDFAnnotation";

export default class CPDFInkAnnotation extends CPDFAnnotation {
  private _quadPoints: any;
  private _quadPointsCount: any;
  private _inkPathCount: any;
  private _inkPointsCount: any;

  async initAnnot (pageIndex: number) {
    if (!this.pages[pageIndex]) {
      this.pages[pageIndex] = await this.messageHandler.sendWithPromise('InitAnnot', {
        page: this.page,
        pageIndex
      })
    }
    return this.pages[pageIndex]
  }

  get quadPoints () {
    return this._quadPoints;
  }

  set quadPoints (data: any) {
    this.setQuadPoints(data);
  }

  async getQuadPoints () {
    let annotPtr = await this.initAnnot(0)
    this._quadPoints = await this.messageHandler.sendWithPromise('GetQuadPoints', {
      page: this.page,
      annot: annotPtr
    })
    return this._quadPoints
  }

  async setQuadPoints (data: any) {
    const { points } = data
    let annotPtr = await this.initAnnot(0)
    return await this.messageHandler.sendWithPromise('SetQuadPoints', {
      page: this.page,
      annot: annotPtr,
      points,
      pointsLength: points.length
    })
  }

  async getQuadPointsCount () {
    this._quadPointsCount = await this.messageHandler.sendWithPromise('GetQuadPointsCount', {
      page: this.page
    })
    return this._quadPointsCount
  }

  async getInkPathCount () {
    this._inkPathCount = await this.messageHandler.sendWithPromise('GetInkPathCount', {
      page: this.page
    })
    return this._inkPathCount
  }

  async getInkPointsCount (data: any) {
    const { index } = data
    this._inkPointsCount = await this.messageHandler.sendWithPromise('GetInkPointsCount', {
      page: this.page,
      index
    })
    return this._inkPointsCount
  }

  async getInkPoints (data: any) {
    const { index } = data
    let annotPtr = await this.initAnnot(0)
    return await this.messageHandler.sendWithPromise('GetInkPoints', {
      page: this.page,
      annot: annotPtr,
      index
    })
  }
}
