// @ts-nocheck
import CPDFAnnotation from "./CPDFAnnotation";

export default class CPDFLineAnnotation extends CPDFAnnotation {
  private _linePoint: any;
  private _lineTailType: any;
  private _lineType: any;

  async initAnnot (pageIndex: number) {
    if (!this.pages[pageIndex]) {
      this.pages[pageIndex] = await this.messageHandler.sendWithPromise('InitAnnot', {
        page: this.page,
        pageIndex
      })
    }
    return this.pages[pageIndex]
  }

  get linePoint () {
    return this._linePoint;
  }

  set linePoint (data: any) {
    this.setLinePoint(data);
  }

  async getLinePoint () {
    let annotPtr = await this.initAnnot(0)
    this._linePoint = await this.messageHandler.sendWithPromise('GetLinePoint', {
      page: this.page,
      annot: annotPtr
    })
    return this._linePoint
  }

  async setLinePoint (data: any) {
    const { startPointX, startPointY, endPointX, endPointY } = data
    let annotPtr = await this.initAnnot(0)
    return await this.messageHandler.sendWithPromise('SetLinePoint', {
      annot: annotPtr,
      startPointX,
      startPointY,
      endPointX,
      endPointY
    })
  }

  get lineTailType () {
    return this._lineTailType;
  }

  set lineTailType (data: any) {
    this.setLineTailType(data);
  }

  async getLineTailType () {
    let annotPtr = await this.initAnnot(0)
    this._lineTailType = await this.messageHandler.sendWithPromise('GetLineTailType', {
      annot: annotPtr
    })
    return this._lineTailType
  }

  async setLineTailType (data: any) {
    const { lineType } = data
    let annotPtr = await this.initAnnot(0)
    return await this.messageHandler.sendWithPromise('SetLineTailType', {
      annot: annotPtr,
      lineType
    })
  }

  get lineType () {
    return this._lineType;
  }

  set lineType (data: any) {
    this.setLineType(data);
  }

  async getLineType () {
    let annotPtr = await this.initAnnot(0)
    this._lineType = await this.messageHandler.sendWithPromise('GetLineType', {
      annot: annotPtr
    })
    return this._lineType
  }

  async setLineType (data: any) {
    const { lineType } = data
    let annotPtr = await this.initAnnot(0)
    return await this.messageHandler.sendWithPromise('SetLineType', {
      annot: annotPtr,
      lineTypeHead: lineType.head,
      lineTypeTail: lineType.tail,
    })
  }
}
