export default class Rect {
  left: number
  top: number
  right: number
  bottom: number

  constructor({
    left,
    top,
    right,
    bottom
  }: {
    left: number;
    top: number;
    right: number;
    bottom: number;
  }) {
    this.left = left
    this.top = top
    this.right = right
    this.bottom = bottom
  }

  getWidth() {
    return Math.abs(this.left - this.right)
  }
  
  getHeight() {
    return Math.abs(this.bottom - this.top)
  }

  getRect() {
    return {
      left: this.left,
      top: this.top,
      right: this.right,
      bottom: this.bottom
    }
  }

  setRect(rect: {
    left: number;
    top: number;
    right: number;
    bottom: number;
  }) {
    if (rect.left === this.left && rect.top === this.top && rect.right === this.right && rect.bottom === this.bottom) return
    Object.assign(this, rect)
  }
}
