importScripts("/lib/ComPDFkit.js")

async function sleep(delay) {
  console.log(9099)
  await new Promise((resolve) => setTimeout(resolve, delay))
}

let renders = []
let workTask = null
let loadFlag = false

let ComPDFKitJS = {}
let DataArray = []
let PageSize = {}
let Rect = {}

let EditCharPlace = {}
let EndEditCharPlace = {}

class CPDFDocument {

  async InitDocument() {
    while (!runtimeLoaded()) {
      await sleep(100)
    }
    console.log(999)
    this.doc = Module._InitDocument()
  }

  LoadFile(buf) {
    ComPDFKitJS.opened_files = [];
    ComPDFKitJS.opened_files[0] = buf;
  }

  LoadDocumentByStream(data) {
    const { doc, fileId, len, password } = data
    return Module._LoadDocumentByStream(doc, fileId, len, password)
  }

  GetPageCount(data) {
    const { doc } = data
    return Module._GetPageCount(doc)
  }

  GetPageSize(data) {
    const { doc, pageIndex } = data
    return getPageSize(doc, pageIndex)
  }

  InitPage(data) {
    const { doc, pageIndex } = data
    return Module._GetPage(doc, pageIndex)
  }

  RenderPageBitmapWithMatrix(data) {
    const { page, scale, left, right, bottom, top, mode, flag, form } = data
    let pixelNum = (right - left) * (bottom - top)
    let imageBytes = pixelNum * 4
    let imageptr = _malloc(imageBytes)
    for (var i = 0; i < pixelNum; i++) {
      Module.HEAP32[imageptr / 4 + i] = 0
    }

    Module._RenderPageBitmapWithMatrix(page, scale, left, right, bottom, top, mode, imageptr, flag, form)
    let imageArray = new Uint8Array(imageBytes)
    for (var i = 0; i < imageBytes; i += 4) {
      //bgra 转 rgba
      imageArray[i] = Module.HEAPU8[imageptr + i + 2]
      imageArray[i + 1] = Module.HEAPU8[imageptr + i + 1]
      imageArray[i + 2] = Module.HEAPU8[imageptr + i]
      imageArray[i + 3] = Module.HEAPU8[imageptr + i + 3]
    }
    _free(imageptr)

    return imageArray
  }

  InsertPage(data) {
    const { doc, pageIndex, width, height, mode } = data
    return Module._InsertPage(doc, pageIndex, width, height, '', 0);
  }

  SaveDocumentByStream(data) {
    const { doc, type } = data
    DataArray = []
    Module._SaveDocumentByStream(doc, type);
    let pdfData = []
    for (let i = 0; i < DataArray.length; i++) {
      let subArray = new Uint8Array(DataArray[i])
      pdfData.push(subArray)
    }
    DataArray = []
    return pdfData
  }

  PushRenderTask(workdata) {
    const { uid, msgId, cmd, data } = workdata
    renders = []
    for (let pageInfo of data.pagesInfo) {
      let pageIndex = pageInfo.pageIndex
      let pdfPage = this.InitPage({ doc: data.doc, pageIndex: pageIndex - 1 })

      let param = {
        page: pdfPage,
        scale: data.zoom,
        left: 0,
        right: parseInt(pageInfo.width),
        bottom: parseInt(pageInfo.height),
        top: 0,
        mode: -1,
        flag: 0,
        form: false
      }

      let imageArray = this.RenderPageBitmapWithMatrix(param)

      postMessage({
        uid,
        msgId,
        cmd,
        data: {
          imageArray: imageArray,
          pageIndex: pageIndex,
          rect: {
            left: 0,
            top: 0,
            width: pageInfo.width,
            height: pageInfo.height
          }
        }
      })
    }

    postMessage({
      uid,
      msgId,
      cmd: "taskFinished"
    })
  }

  CreateAnnot(data) {
    const { doc, page, type } = data
    return Module._CreateAnnot(doc, page, type)
  }

  SetAnnotParam(data) {
    const { annot, page } = data

    Module._SetAnnotFilledRGBColor(annot, 255, 0, 0)
    //Module._SetAnnotRGBColor(annot,0,255,0)
    Module._SetAnnotBorderWidth(annot, 2)
    Module._SetAnnotRect(page, annot, 100, 200, 200, 100)
    //Module._UpdateAnnotAp(annot,0)
    let border = Module._GetAnnotBorderWidth(annot)
    // console.log("border width:  "+border)
  }

  InitEditPage(page) {
    let editPage = Module._InitEditPage(page)
    return editPage
  }

  BeginEdit(editPage) {
    Module._BeginEdit(editPage, 1)
    return true
  }

  EndEdit(editPage) {
    Module._EndEdit(editPage)
    return true
  }

  IsTextArea(areaPtr) {
    return Module._IsTextArea(areaPtr)
  }

  GetEditAreaCount(editPage) {
    return Module._GetEditAreaCount(editPage)
  }

  CreateNewTextArea(data) {

  }

  GetEditArea(data) {
    const { editPage, index } = data
    let area = Module._GetEditArea(editPage, index)
    return area
  }

  InsertText(data) {
    const { areaPtr, text } = data
    let textPtr = stringToNewUTF8(text)
    let result = Module._InsertText(areaPtr, 0, 0, 0, -1, textPtr, false)
    return result
  }

  MovePage(data) {
    const { doc, from, to } = data
    return Module._MovePage(doc, from, to)
  }

  RotatePage(data) {
    const { page, rotation } = data
    Module._RotatePage(page, rotation)
  }

  RemovePage(data) {
    const { doc, pageIndex } = data
    return Module._RemovePage(doc, pageIndex)
  }

  RemoveAnnot(annotPtr) {
    return Module._RemoveAnnot(annotPtr)
  }

  GetTextByRange(data) {
    const { areaPtr, start, end } = data
    let result = Module._GetTextByRange(
      areaPtr,
      start.SectionTndex, start.LineTndex, start.RunTndex, start.CharTndex,
      end.SectionTndex, end.LineTndex, end.RunTndex, end.CharTndex,
    )
    let gg = UTF8ToString(result)
    //   console.log(gg)
    return result
  }

  GetBeginAndEndCharPlace(areaPtr) {
    EditCharPlace = {}
    EndEditCharPlace = {}

    Module._GetBeginAndEndCharPlace(areaPtr)

    return { start: EditCharPlace, end: EndEditCharPlace }
  }

  SetTextAligningBlock(data) {
    const { areaPtr, type } = data
    return Module._SetTextAligningBlock(areaPtr, type, false)
  }

  SetCharsFontRederingMode(data) {
    const { areaPtr, isBold, start, end } = data
    return Module._SetCharsFontRederingMode(
      areaPtr,
      start.SectionTndex, start.LineTndex, start.RunTndex, start.CharTndex,
      end.SectionTndex, end.LineTndex, end.RunTndex, end.CharTndex,
      isBold ? 2 : 0)
  }

  SetCharsFontSize(data) {
    const { areaPtr, start, end, fontSize, autoBlock } = data
    return Module._SetCharsFontSize(
      areaPtr,
      start.SectionTndex, start.LineTndex, start.RunTndex, start.CharTndex,
      end.SectionTndex, end.LineTndex, end.RunTndex, end.CharTndex,
      fontSize,
      autoBlock)
  }

  SetCharsFontColor(data) {
    const { areaPtr, start, end, color } = data
    return Module._SetCharsFontColor(
      areaPtr,
      start.SectionTndex, start.LineTndex, start.RunTndex, start.CharTndex,
      end.SectionTndex, end.LineTndex, end.RunTndex, end.CharTndex,
      color.r, color.g, color.b)
  }

  DeleteChar(data) {
    const { areaPtr, start, end } = data
    return Module._DeleteChar(
      areaPtr,
      start.SectionTndex, start.LineTndex, start.RunTndex, start.CharTndex,
      end.SectionTndex, end.LineTndex, end.RunTndex, end.CharTndex, false
    )
  }

  CreateWidget(data) {
    const { doc, page, type } = data
    return Module._CreateWidget(doc, page, type)
  }

  SetWidgetParam(data) {
    const { annot, page } = data
    let textPtr = stringToNewUTF8("fieldName_wasm")
    Module._SetAnnotBorderWidth(annot, 2)
    Module._SetWidgetFieldName(annot, textPtr)
    //Module._SetWidgetBackgroundRGBColor(annot,0,255,0)
    Module._SetWidgetBorderRGBColor(annot, 255, 0, 255)
    Module._SetAnnotRect(page, annot, 100, 200, 400, 300)
    //Module._UpdateAnnotAp(annot,0)
    let border = Module._GetAnnotBorderWidth(annot)
    Module._UpdateFormAp(annot)

    // console.log("border width:  "+border)
  }

  SetWidgetBorderRGBColor(data) {
    const { annot, color } = data
    return Module._SetWidgetBorderRGBColor(annot, color.r, color.g, color.b)
  }

  SetWidgetBackgroundRGBColor(data) {
    const { annot, color } = data
    return Module._SetWidgetBackgroundRGBColor(annot, color.r, color.g, color.b)
  }
}

async function dispatchWork(evt) {
  const { uid, msgId, cmd, data } = evt.data
  if (cmd === "initDoc") {
    let pdfDoc = new CPDFDocument();
    pdfDoc.uid = uid
    workTask.addWork(pdfDoc);
    await pdfDoc.InitDocument()
    console.log(uid,msgId,cmd,)
    postMessage({
      uid,
      msgId,
      cmd,
      data: pdfDoc.doc
    })
    return
  }

  if (cmd == "close") {
    workTask.removeWork()
    postMessage({
      uid,
      msgId,
      cmd,
      data
    })
    return
  }

  if (cmd == "PushRenderTask") {
    workTask.work[cmd](evt.data)
    return
  }

  if (workTask.work) {
    let result = workTask.work[cmd](data)
    postMessage({
      uid,
      msgId,
      cmd,
      data: result
    })
  }
}

class PDFWorker {
  constructor() {
    addEventListener("message", dispatchWork)
  }

  addWork(data) {
    this.removeWork();
    this.work = data
  }

  removeWork() {
    if (this.work) {
      this.work.ClearDocument()
    }
    this.work = null
  }

}

function runtimeLoaded() {
  return runtimeInitialized
}

function createUTF16string(str) {
  var length = lengthBytesUTF16(str) + 2; // 加2是为了空字节终止符
  var strptr = _malloc(length); // 在 Emscripten 的堆中为字符串分配内存
  stringToUTF16(str, strptr, length); // 将字符串转换为 UTF-16 编码
  return strptr;
}

function getPageSize(doc, pageIndex) {
  PageSize.Width = 0
  PageSize.Height = 0
  _GetPageSizeForIndex(doc, pageIndex)

  let outline = _NewOutlineRoot(doc)
  let urlword = "hello url"
  let textPtr = stringToNewUTF8(urlword)
  _SetUri(outline, textPtr)
  //console.log("set success")
  let result = _GetUri(outline)
  let uri_text = UTF8ToString(result)
  // console.log(uri_text)

  let titleUrl = "1我ABCDERFHIJklmnopqrstuvwxyz1"
  //let titlePtr= stringToNewUTF8(titleUrl)
  let titlePtr = stringToNewUTF8(titleUrl)
  _SetTitle(outline, titlePtr)
  let result_title = _GetTitle(outline)
  let title_text = UTF8ToString(result_title)
  //  console.log(title_text)

  return {
    width: PageSize.Width,
    height: PageSize.Height
  }
}

workTask = new PDFWorker()
